class point x_p y_p =
object
  val mutable x = x_p
  val mutable y = y_p
  method x = x
  method y = y
  method move = function (dx, dy) -> x <- x + dx; y <- y + dy
end;;

let phony_point x_p y_p =
object
  method x = 42
  method y = 42
  method move = function (dx, dy) -> ()
end;;

let print_point (p : point) =
  print_endline ("(" ^ string_of_int p#x ^ ", " ^ string_of_int p#y ^ ")");;

(**** TESTS ****
new point;;
let p = new point 7 3;;
p;;
p#x;;
p#y;;
p#move (1, -42);;
p#x;;
p#y;;
let p_phony = phony_point 7 3;;
p_phony;;
p_phony#x;;
p_phony#y;;
p_phony#move (1, -42);;
p_phony#x;;
p_phony#y;;
print_point p;;
print_point p_phony;;
*)
